<template>
    <section class="projects">
        <div class="container">
            <Subtitle text="My Work" />
            <h3 class="projects__subtitle">Hand-picked projects for you to see.</h3>
            <div class="grid grid--2">
                <div>
                    <div class="project-controls">
                        <button class="btn btn--prev" @click="handlePrev">
                            <svg stroke="#fff" fill="none" stroke-width="0" viewBox="0 0 24 24" height="1em" width="1em" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M7 16l-4-4m0 0l4-4m-4 4h18"></path></svg>
                        </button>
                        <span class="project__number">
                            <span v-if="current < 9">0{{ current + 1 }}</span> / 
                            <span v-if="projects.length < 10">0{{ projects.length }}</span>
                        </span>
                        <button class="btn btn--next" @click="handleNext">
                            <svg stroke="#fff" fill="none" stroke-width="0" viewBox="0 0 24 24" height="1em" width="1em" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M17 8l4 4m0 0l-4 4m4-4H3"></path></svg>
                        </button>
                    </div>

                    <div class="project-info">
                        <h4 class="project__title">{{ projects[current].title }}</h4>
                        <p class="project__description">{{ projects[current].text }}</p>
                        <p class="project__technology">
                            <span
                            v-for="(technology, index) in projects[current].technologies" 
                            :key="index"
                            >{{ technology }}</span>
                        </p>
                        <Button @click.native="openProject(current)" title="View Project" />
                    </div>
                </div>

                <div class="project-img__wrapper">
                    <div class="project__img">
                        <img :src="require('../assets/projects/' + projects[current].img + '.jpg')" alt="">
                    </div>
                    <img src="../assets/device-frame.png" alt="" class="project__frame">
                </div>
            </div>
        </div>
    </section>
</template>

<script>
import Button from './Button.vue';
import Subtitle from './Subtitle.vue'
import gsap from 'gsap'
import { ScrollTrigger } from 'gsap/ScrollTrigger';

export default {
    components: { Subtitle, Button },
    data: () => ({
        projects: [
            { 
                title: 'My Homejam', 
                text: 'Homejam is a Hindu website where you can meet and talk with your favorite artist.', 
                technologies: ['React', 'Next.js', 'SCSS', 'Styled Components', 'Ant Design', 'Stripe'],
                link: 'https://myhomejam.com/',
                img: 'project-1'
            },
            { 
                title: 'FlipChain', 
                text: 'FlipChain is a website where you can monitor your crypto compound trade wins/losses.', 
                technologies: ['Vue', 'Nuxt.js', 'SCSS', 'Vuetify', 'Stripe'],
                link: 'https://flipchain.ai/',
                img: 'project-2'
            },
            { 
                title: 'Telegraf', 
                text: 'Telegraf is a tool for recording videos and tracking Gmail messages.', 
                technologies: ['Vue', 'SCSS', 'Vuetify'],
                link: 'https://zen-goldstine-f1afd1.netlify.app/#/',
                img: 'project-3'
            },
            { 
                title: 'Strong Password Generator', 
                text: 'A website that automatically generates strong and unpredictable passwords.', 
                technologies: ['Vue', 'SCSS'],
                link: 'https://admiring-jepsen-c29ba5.netlify.app/',
                img: 'project-4'
            },
            { 
                title: 'Medly Pharmacy', 
                text: 'Full-service local pharmacy that can fill specialty, brand and generic medications for a wide variety of health conditions.', 
                technologies: ['HTML', 'CSS', 'JavaScript'],
                link: 'https://compassionate-visvesvaraya-f84dd2.netlify.app/',
                img: 'project-5'
            },
            { 
                title: 'Gameface', 
                text: 'Gameface is an app that helps people suffering from mental illness like Anxiety and Depression.', 
                technologies: ['HTML', 'CSS', 'JavaScript'],
                link: 'https://musing-sammet-0e6a68.netlify.app/#',
                img: 'project-6'
            },
            { 
                title: 'Adtreme', 
                text: 'Adtreme is an online marketing agency in Singapore that generates more sales, leads and appointments for your business via SEO services and Social Media channels.', 
                technologies: ['HTML', 'CSS', 'JavaScript', 'Bootstrap'],
                link: 'https://adtreme.com/',
                img: 'project-7'
            },
        ],
        current: 0,
    }),
    methods: {
        animation() {
            gsap.fromTo(".project-img__wrapper, .project-info", 
                {x: -40, opacity: 0}, 
                {x: 0, opacity: 1, duration: 0.4}
            );
        },
        subtitleAnimation() {
            gsap.registerPlugin(ScrollTrigger);

            gsap.fromTo(".projects .subtitle-line", 
                {width: 0}, 
                {width: 60, duration: 1, scrollTrigger: {
                    trigger: '.projects',
                    start: 'top 75%',
                }}
            );

            gsap.fromTo(".projects .subtitle", 
                {opacity: 0}, 
                {opacity: 1, duration: 1, scrollTrigger: {
                    trigger: '.projects',
                    start: 'top 75%',
                }}
            );
        },
        handlePrev() {
            if (this.current > 0) {
                this.current--
            } else {
                this.current = this.projects.length - 1;
            }
            this.animation();
        },
        handleNext() {
            if(this.current < this.projects.length - 1){
               this.current++
            } else {
                this.current = 0;
            }
            this.animation();
        },
        openProject(current) {
            const projectLink = this.projects[current].link;
            window.open(projectLink);
        },
    },
    mounted() {
        this.subtitleAnimation();
    }
}
</script>

<style scoped>
.projects {
    padding: 40px 0;
}
.project__number {
    color: #fff;
    font-weight: 600;
    font-size: 18px;
    display: inline-block;
    margin: 0 14px;
}
.project__title {
    font-size: 34px;
    color: #fff;
    font-weight: 600;
    margin-top: 40px;
    margin-bottom: 20px;
}
.project__description {
    margin-bottom: 40px;
}
.projects__subtitle {
    color: #fff;
    font-size: 40px;
    max-width: 460px;
    margin-bottom: 80px;
}
.project__technology {
    margin-bottom: 50px;
}
.project__technology span {
    font-size: 14px;
    margin-right: 20px;
    margin-bottom: 10px;
    background-color: #212531;
    padding: 4px 10px;
    border-radius: 5px;
    display: inline-block;
}
.project-img__wrapper {
    position: relative;
}
.project__frame {
    position: absolute;
    top: 0;
}
.project__img img{
    padding: 15px;
}
.btn--next, 
.btn--prev {
    background: #212531;
    height: 50px;
    width: 50px;
    border-radius: 5px;
}
.btn--next svg, 
.btn--prev svg {
    margin-top: 6px;
    font-size: 28px;
}
.project-controls {
    display: flex;
    align-items: center;
}

@media screen and (min-width: 768px) {
    .projects {
        padding: 60px 0;
    }
}

@media screen and (min-width: 1200px) {
    .projects {
        height: 100vh;
        display: grid;
    }
    .project-img__wrapper {
        min-height: 400px;
        max-height: 400px;
    }
    /* .project-img__wrapper {
        transform: rotate(8deg);
    } */
}
</style>